/* File: alarm.h
 *
 * Time-stamp: <21-May-2003 19:20:32 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: me
 *
 * Description: 
 * 
 */
# ifndef ALARM_H_INCLUDED
# define ALARM_H_INCLUDED

class AlarmItem
{
public:
 int DBkey;
 time_t time;
 int id;

 AlarmItem()
 {
  time=0x7FFFFFFF;
 }
};

class AlarmList
{
public:
 AlarmItem * ent;
 int count;
 int max;
 int next;
 
 AlarmList()
 {
  ent = NULL;
  count =0;
  max =0;
  next=-1;
 }
 ~AlarmList()
 {
  if( ent != NULL)
   {
    delete [] ent;
   }
  ent = NULL;
 }

 int extend()
 {
  AlarmItem *tmp;
  
  //  printf("extend APL\n\n\n");
  tmp = new (AlarmItem ) [max +64];
  if(tmp == NULL)
   return false;
  if(ent != NULL)
   {
    memcpy(tmp,ent,sizeof(AlarmItem )*max);
    delete [] ent;
   }
  ent  = tmp;
  max += 64;
  return true;
 }

 void add(int key, time_t tim, int id)
 {
  if(count >= max)
   extend();
  
  ent[count].DBkey = key;
  ent[count].time  = tim;
  ent[count].id    = id;
  count++;
 }

 void sort()
 {
  qsort(ent,count,sizeof(AlarmItem),AlarmList::compare);
 }
 static int compare (const void * v1,const void * v2)
 {
  AlarmItem * a1 = (AlarmItem*) v1;
  AlarmItem * a2 = (AlarmItem*) v2;
  
  return(a1->time - a2->time);
 }

 int firstAfter(int tim)
 {
  int p0,p1,p2;

  if(count <0)
   return -1;

  p0=0;
  p2 =count-1;

  if(ent[p2].time <  tim)
   return -1;

  do
   {
    p1 = (p0+p2)>>1;
    if(ent[p1].time ==  tim)
     {
      while(ent[p1].time ==  tim)
       p1++;
      return p1;
     }
    if(ent[p1].time>tim)
     p2=p1;
    if(ent[p1].time<tim)
     p0=p1;
   }while(p2-p1>1);
    
  return p2;
 }

};

extern AlarmList alarms;


# endif
