/* File: appointment.h
 *
 * Time-stamp: <01-Jun-2003 19:23:57 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: me
 *
 * Description: 
 * 
 */
# ifndef APPOINTMENT_H_INCLUDED
# define APPOINTMENT_H_INCLUDED

//#include <time.h>

// extern FILE *fpl;
// #include "timeDef.h"

// extern char DBsep,DBsep2;

unsigned int swapEndianess32(unsigned int i);
unsigned int swapEndianess32(unsigned int *i);
void addCategory(int id,const char *txt);
void addLocation(int id,const char *txt);
char * add2Buffer(char *buf,int bufLen,int val, char sep);
char * add2Buffer(char *buf,int bufLen,char *txt, char sep,int add0=true);
char * add2Buffer(char *buf,int bufLen,char *txt,int txtLen, char sep);


#define REPEAT_TYPE_NONE  0
#define REPEAT_TYPE_DAY   1
#define REPEAT_TYPE_WEEK  2
#define REPEAT_TYPE_MONTH 3
#define REPEAT_TYPE_YEAR  4
#define REPEAT_TYPE_MONTH_BY_DAY 5

#define SUNDAY     0x40
#define MONDAY     0x01
#define TUESDAY    0x02
#define WEDNESDAY  0x04
#define THURSDAY   0x08
#define FRIDAY     0x10
#define SATURDAY   0x20

// #define MAX_LOCATION 256
// #define MAX_CATEGORIES 256

#define CATEGORY_OTHER 0
#define CATEGORY_ALL   -1

#define LOCATION_OTHER 0
#define LOCATION_ALL   -1

const int weekDayFlagByIndex [7] = {SUNDAY,MONDAY,TUESDAY,WEDNESDAY,THURSDAY,FRIDAY,SATURDAY};

#define SECONDS_PER_DAY 86400
#define SECONDS_PER_WEEK 604800

// char *skip2NextSep(char *t,char sep);
// int unsplit(char **tp,int max, char *s,char sep);



class AppointmentRepeat
{
public:
 int type;
 int intervall;
 time_t until;
 time_t refStart;
 short int weekInMonth;   // 0-4
 short int dayInMonth;  // 0-31
 short int dayFlags;
 short int fast;
 int * exceptions;
 int exceptionCount; 
 int exceptionMax;

 AppointmentRepeat()
 {
  type = REPEAT_TYPE_NONE;
  until =0;
  exceptions = NULL;
  exceptionCount = 0;
  exceptionMax   = 0;
 }
 ~AppointmentRepeat()
 {
  if (exceptions != NULL)
   delete [] exceptions;
 }

 void fill(int start, int repType, int repIntervall,int wim, int repDayFlags, int repUntil)
 {
  struct tm *lt,buf;
  type        = repType;
  if(type != REPEAT_TYPE_NONE)
   {
    if(repIntervall<1)
     intervall =1;
    else
     intervall   = repIntervall;
    
    dayFlags    = repDayFlags;
    if(repUntil<2147483647)
     {
      lt   = localtime((time_t * ) &repUntil);
      lt->tm_hour=23;
      lt->tm_min =59;
      lt->tm_sec =59;
      until       = mktime(lt);
     }
    else
     {
      until = repUntil;
     }
    weekInMonth =  wim;
    
    if(type==REPEAT_TYPE_WEEK)
     {
      int bc=0,b=1;
      while ( bc<2 && b <256)        // Look if more than one dayflag is set
       {
	if( (dayFlags &b ) > 0)
	 bc++;
	b = b <<1;
       }
      if(bc <=1)
       {
	fast=true;
	refStart = start;
       }
      else
       {
	int wday;
	fast = false;
	lt   = localtime((time_t * ) &start);
	wday = (lt->tm_wday +6) %7;
	refStart = start - SECONDS_PER_DAY * wday;  // refStart point to the beginning of the week of the first 
       }                                            // instance of the appointment
     }
    else
     {
      refStart    = start;
      fast =false;           // fast is onlt used with REPEAT_TYPE_WEEK
     }
   }
 }
 void reset()
 {
  type = REPEAT_TYPE_NONE;
  until =0;
  if (exceptions != NULL)
   delete [] exceptions;
  exceptions = NULL;
  exceptionCount = 0;
  exceptionMax   = 0;
 }

 void addException(int tim)
 {
  //  printf("add exception\n");
  if(exceptionCount>= exceptionMax)
   extendExpetions();
  if(exceptionCount< exceptionMax)
   {
    exceptions[exceptionCount] = tim;
    exceptionCount++;
   }
 }
 int extendExpetions()
 {
  int *tmp;
  
  //  printf("extend Expections\n");
  tmp = new int [exceptionMax+16];
  if( exceptions != NULL)
   {
    memcpy(tmp,exceptions,sizeof(int) * exceptionMax);
    delete [] exceptions;
   }
  exceptions = tmp;
  exceptionMax +=16;
 }
};

class Appointment
{
public:
 int id;
 time_t start;
 time_t stop;
 int alarm[4];
 time_t alarmTime[4];
 char *title;
 char *descr;
 char *hiddenText;
 char priv;
 char hidden;
 char canceled;
 char journal;
 char *location;
 short int category;
 AppointmentRepeat rep;

 char *DBline,*tmp;
 int DBkey,DBlen;

 Appointment()
 {
  reset0();
 }

 Appointment(int aid,int key,Appointment *a)
 {
  reset0();
  fill(aid,key,a);
 }
 Appointment (int aid,int key, char *dbline,int len)
 {
  reset0();
  fill(aid,key,dbline,len);
 }

 ~Appointment()
 {
  if(title != NULL)
   delete [] title;
  if(descr != NULL)
   delete [] descr;
  if(hiddenText != NULL)
   delete [] hiddenText;
  if(location != NULL)
   delete [] location;
 }
 void reset0()
 {
  title  = NULL;
  descr  = NULL;
  hiddenText = NULL;
  start  = 0;
  stop   = 0;
  alarm[0]= -1;
  alarm[1]= -1;
  alarm[2]= -1;
  alarm[3]= -1;
  priv    =false;
  journal =false;
  hidden  =false;
  canceled=false;
  //  location=LOCATION_OTHER;
  location=NULL;
  category=CATEGORY_OTHER;
  id      = -1;
  DBline  = NULL;
  DBkey   = -1;
 }
 void reset()
 {
  if(location != NULL)
   delete [] location;
  if(title != NULL)
   delete [] title;
  if(descr != NULL)
   delete [] descr;
  if(hiddenText != NULL)
   delete [] hiddenText;
  location=NULL;
  hiddenText = NULL;
  title  = NULL;
  descr  = NULL;
  start  = 0;
  stop   = 0;
  alarm[0]= -1;
  alarm[1]= -1;
  alarm[2]= -1;
  alarm[3]= -1;
  priv    =false;
  journal =false;
  hidden  =false;
  canceled=false;
  location=LOCATION_OTHER;
  category=CATEGORY_OTHER;
  id     = -1;
 }

 void fill(int aid,int key, char *dbline,int len)
 {
  char *tp[32],*tp2[32];
  int anz, flag=0,l;

  reset();
  
  
  id=aid;
  DBkey =key;
  DBlen=len;
  DBline = new char [len+2];
  memcpy(DBline,dbline,sizeof(char) *(len+2));

  category  = DBline[1];


  anz =  unsplit(tp,31,dbline+2,DBsep,len-2);

  //  printf("Add App key=%08X anz=%d\n",key,anz);
  if(anz <14)
   {
    printf("Warning:\nAppointment key=%08X has not enough fields, skipping\n",DBkey);
   }
  else
   {
    
    journal  =  atoi(tp[3]);
    start    =  atoi(tp[0]);
    stop     =  atoi(tp[1]);
    if(start> stop)
     {
      printf("Warning:\nappointment %s @ %8d ends before it beginns\n",tp[13],start);
      stop =  start;
     }

    if(journal == 0)
     alarm[0] =  atoi(tp[2]);
    else
      alarmTime[0] =  atoi(tp[2]);

    if(DBInputVersion== 11)
     {
      int subAnz = unsplit(tp2,255,tp[12],DBsep2);
      if(subAnz>1  && subAnz< 7)
       printf("WARNING: uncompletet extension data %d on %s)\n",subAnz,tp[13]);
      if(subAnz >0)
       fillLocation(tp2[0]);
      if(journal == 0)
       {
	for (int i=1; i<4;i++)
	 if(subAnz >i)
	  alarm[i] =  atoi(tp2[i]);
       }
      else
       {
	for (int i=1; i<4;i++)
	 if(subAnz >i)
	  alarmTime[i] =  atoi(tp2[i]);
       }
      if(subAnz >4)
       fillDescr(tp2[4]);
      if(subAnz >5)
       flag     =  atoi(tp2[5]);
      if(subAnz >6)
       fillHiddenText(tp2[6]);
     } 

    if(journal == 0)
     {
      alarm2alarmTime();

      rep.type =  atoi(tp[4]);
      if(rep.type != REPEAT_TYPE_NONE) 
       {
	int sunday,df;
	int repIntervall,repUntil,repDays,repWeek,repType;
	repIntervall   =  atoi(tp[5]);
	repUntil       =  atoi(tp[6]);
	if(repUntil == 0)
	 repUntil = 0x7FFFFFFF;
	
	
	df = atoi(tp[7]);
	sunday = df & 0x1;
	repDays    =  (df >> 1 ) + (sunday <<6);
	rep.dayInMonth  =atoi(tp[8]);
	repWeek =  atoi(tp[9])-1;
	if(rep.type == REPEAT_TYPE_MONTH)
	 if(rep.dayInMonth==0 && rep.weekInMonth>=0)
	  rep.type = REPEAT_TYPE_MONTH_BY_DAY;
	rep.fill(start,rep.type,repIntervall,repWeek,repDays,repUntil);       

	char **tpe;
	int ec,ec2,l;
	ec =  atoi(tp[10]);
	if(ec >0)
	 {
	  tpe = new (char *) [ec+4];
	  l =strlen(tp[11]);
	  ec2 = unsplit(tpe,ec+2,tp[11],',',l+1);
	  for(int e=0;e<ec2; e++)
	   rep.addException(atoi(tpe[e]));
	 }
       }
     }
    else
     {
      alarmTime2alarm();
      rep.type = REPEAT_TYPE_NONE;
     }


    fillTitle(tp[13]);

    if((flag & DB_FLAG_PRIVATE) > 0 )
     priv = true;
    if((flag & DB_FLAG_HIDDEN) > 0 )
     hidden = true;
    if((flag & DB_FLAG_CANCELED) > 0 )
     canceled = true;
    //    printf("App '%s'/%d added on %d       %d %d %X\n",title,journal,id,rep.type,rep.intervall,rep.dayFlags);

   }
 }
 void fill(int aid,Appointment *a)
 {
  int l;
  id      = aid;
  journal = a->journal;
  priv    = a->priv;
  hidden  = a->hidden;
  canceled= a->canceled;
  if(a->location != NULL)
   fillLocation(a->location);
  else
   location = NULL;

  category= a->category;
  start   = a->start;
  stop    = a->stop;
  for(int i=0;i<4; i++)
   {
//     printf("\t\t\tfill app: alarm %d = %d %d (%p) <- %d %d (%p)\n",i,
// 	   alarm[i],alarmTime[i],this,a->alarm[i],a->alarmTime[i],a );
    alarm[i]     = a->alarm[i];
    alarmTime[i] = a->alarmTime[i];
   }
  if(a->title != NULL)
   fillTitle(a->title);
  else
   title=NULL;

  if(a->descr != NULL)
   fillDescr(a->descr);
  else
   descr=NULL;

  fillRepeat(a);
 }
 void fill(int aid,int key,Appointment *a)
 {
  fill(aid,a);

  if(DBline != NULL)
   delete [] DBline;
  DBline = new char [a->DBlen +4];
  DBlen  = a->DBlen;
  DBkey  = key;
  memcpy(DBline,a->DBline,DBlen);
  DBline[DBlen] ='\0';
  writeDB(DBkey,DBline,DBlen);
  updateAlarm();
 }

 void fillTitle(const char *t)
 {
  int l;
  if (title != NULL)
   delete [] title;
  l = strlen(t);
  title = new char [l+4];
  strncpy(title,t,sizeof(char) * (l+2));
  title[l+2]='\0';
 }
 void fillDescr(const char *t)
 {
  int l;
  if (descr != NULL)
   delete [] descr;
  l = strlen(t);
  descr = new char [l+4];
  strncpy(descr,t,sizeof(char) * (l+2));
  descr[l+2]='\0';
 }
 void fillLocation(const char *t)
 {
  int l;
  if (location != NULL)
   delete [] location;
  l = strlen(t);
  location = new char [l+4];
  strncpy(location,t,sizeof(char) * (l+2));
  location[l+2]='\0';
 }
 void fillHiddenText(const char *t)
 {
  int l;
  if (hiddenText != NULL)
   delete [] hiddenText;
  l = strlen(t);
  hiddenText = new char [l+4];
  strncpy(hiddenText,t,sizeof(char) * (l+2));
  hiddenText[l+2]='\0';
 }

 void alarmTime2alarm()
 {
  for(int i=0;i<4; i++)
   if(alarmTime[i] >0)
    alarm[i] = (start - alarmTime[i]) /60;
   else
    alarm[i] = -1;
 }

 void alarm2alarmTime()
 {
  for(int i=0;i<4; i++)
   if(alarm[i] >=0)
    alarmTime[i] = start - alarm[i] *60;
   else
    alarmTime[i] =0;
 }

 void fillRepeat(Appointment *src)
 {
  rep.type  = src->rep.type;

  if(rep.type == REPEAT_TYPE_NONE)
   rep.reset();
  else
   {
    rep.fill(start,src->rep.type,src->rep.intervall,src->rep.weekInMonth,src->rep.dayFlags,src->rep.until);
    rep.exceptionCount  = src->rep.exceptionCount;
    if(rep.exceptionCount ==0)
     rep.exceptionMax    = 0;
    else
     {
      rep.exceptionMax    = src->rep.exceptionMax;
      rep.exceptions      = new  int [rep.exceptionMax];
      memcpy(rep.exceptions, src->rep.exceptions,sizeof(int) * rep.exceptionMax);
     }
   }
 }



 void copy(Appointment *src)
 {
  int myid=id;
  reset0();
  fill(myid,src);
 }

 void update(Appointment *src)
 {
  int shift;
  int update=false;
  int d=0;
  if(id == src->id)
   {
    if(src->DBlen != DBlen)
     update =true;
    else if ( memcmp(src->DBline,DBline,sizeof(char)*DBlen) != 0 )
     update =true;
   
    if(update)
     {
      //      printf("update App id=%d, key=%08X  (d=%d l=%d vs %d)\n",id,DBkey,d,src->DBlen,DBlen);
      shift = src->start - start;
      journal = src->journal;
      priv    = src->priv;
      hidden  = src->hidden;
      canceled= src->canceled;
      if(src->location != NULL)
       fillLocation(src->location);
      else
       location = NULL;
      category= src->category;
      start   = src->start;
      stop    = src->stop;
      for(int i=0;i<4; i++)
       {
	alarm[i]     = src->alarm[i];
	alarmTime[i] = src->alarmTime[i];
       }    
      if(src->title != NULL)
       fillTitle(src->title);
      else
       src->title=NULL;
      if(src->descr != NULL)
       fillDescr(src->descr);
      else
       descr=NULL;

      if( rep.type  != src->rep.type)
       fillRepeat(src);
      else
       {
	rep.fill(start,src->rep.type,src->rep.intervall,src->rep.weekInMonth,src->rep.dayFlags,src->rep.until);
	if(shift>0)
	 for(int i=0;i<rep.exceptionCount; i++)
	  rep.exceptions[i] += shift;
       }
      
      if(DBline != NULL)
       delete [] DBline;
      DBline = new char [src->DBlen +4];
      DBlen  = src->DBlen;
      memcpy(DBline,src->DBline,DBlen);
      DBline[DBlen] ='\0';
      writeDB(DBkey,DBline,DBlen);
     }
   }
  updateAlarm();
 }

 void addException(int tim)
 {
  rep.addException(tim);
  createDBline();
  writeDB(DBkey,DBline,DBlen);
 }

 void createDBline()
 {
  char *t,*s,buf2[DB_BUFFER_LEN];
  int flags =0x40;

  if(priv)
   flags |= DB_FLAG_PRIVATE;
  if(hidden)
   flags |= DB_FLAG_HIDDEN;
  if(canceled )
   flags |= DB_FLAG_CANCELED;
  
  
  //  DBbuffer[0] = flags;
  DBbuffer[1] = (char ) (category & 0xFF);
  t=DBbuffer+2;
    

  int dayFlags = ((rep.dayFlags & 0x3F) << 1) | ( (rep.dayFlags & 0x40) >> 6) ;
  int dayInMonth=0,weekInMonth=0;
  int repType = rep.type;
  int repUntil;
  if(rep.until == 0x7FFFFFFF)
   repUntil = 0;
  else
   repUntil = rep.type;
  if(rep.type == REPEAT_TYPE_MONTH)
   {
    timeDef td;
    td.set(start);
    dayFlags=0;
    dayInMonth=td.day;
   }
  else if(rep.type == REPEAT_TYPE_MONTH_BY_DAY)
   {
    repType= REPEAT_TYPE_MONTH;
    weekInMonth = rep.weekInMonth;
   }
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),start,         DBsep); // 0
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),stop,          DBsep); // 1
  if(journal == 0)
   t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),alarm[0],     DBsep); // 2
  else
   t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),alarmTime[0], DBsep); // 2
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),journal,       DBsep); // 3
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),repType,            DBsep); // 4
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),rep.intervall, DBsep); // 5
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),repUntil,           DBsep); // 6
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),dayFlags,           DBsep); // 7
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),dayInMonth,         DBsep); // 8
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),weekInMonth,        DBsep); // 9
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),rep.exceptionCount,DBsep);  // 10
  buf2[0]='\0';
  for(int j=0;j<rep.exceptionCount; j++)
   {
    char tmp[64];
    sprintf(tmp,"%d,",rep.exceptions[j]);
    strcat(buf2,tmp);
   }
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),buf2,              DBsep);    //11
  //  printf("saving %d expections : %s\n",rep.exceptionCount,buf2);
  buf2[0]='\0';
  s=buf2;
  s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),location,     DBsep2,false); //12.0
  if(journal == 0)
   for(int i=1;i<4; i++)
    s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),alarm[i],     DBsep2); //12.1 -3
  else
   for(int i=1;i<4; i++)
    s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),alarmTime[i], DBsep2); //12.1 -3
//   s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),alarm[1],     DBsep2); //12.1
//   s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),alarm[2],     DBsep2); //12.2
//   s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),alarm[3],     DBsep2); //12.3
  s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),descr,        DBsep2,false); //12.4
  s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),flags,        DBsep2); //12.5
  s=add2Buffer(s,DB_BUFFER_LEN-(t-buf2),hiddenText,   DBsep2,false); //12.6
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),buf2,        s-buf2,DBsep); //12
  t=add2Buffer(t,DB_BUFFER_LEN-(t-DBbuffer),title,         DBsep); // 13

  DBlen =  t-DBbuffer;

  if(DBline != NULL)
   delete [] DBline;

  DBline = new char [DBlen+4];
  memcpy(DBline,DBbuffer,sizeof(char)*DBlen);
  DBline[DBlen]='\0';
 }

 
 void updateAlarm()
 {
  int tim = time(NULL);
  updateAlarm(tim);
 }
 void updateAlarm(int tim)
 {

  time_t atim[4];
  if(! journal)
   alarm2alarmTime();
  else
   alarmTime2alarm();
  
//   printf("id=%4d: title ='%s' tim=%10d alarms: %10d %10d %10d %10d\n",
//  	 id,title,tim,alarmTime[0],alarmTime[1],alarmTime[2],alarmTime[3]);

  if(alarmTime[0]> tim ||
     alarmTime[1]> tim ||
     alarmTime[2]> tim ||
     alarmTime[3]> tim )
   {
    for(int j=0;j<4; j++)
     if (alarmTime[j]> tim )
      atim[j] = alarmTime[j];
     else
      atim[j] =0;
//     printf("alarmDB: add key %08X: %10d %10d %10d %10d\n",
// 	   DBkey,atim[0],atim[1],atim[2],atim[3]);
    writeAlarmItem2DB(DBkey,atim);
   }
 }

};




class AppointmentPtrList
{
public:
 Appointment **app;
 int count;
 int max;
 int sortSize;
 int scanPtr;

 AppointmentPtrList()
 {
  app   = NULL;
  count = 0;
  max   = 0;
  sortSize = 0;
  scanPtr=-1;
 }

 ~AppointmentPtrList()
 {
  if( app != NULL)
   {
    reset();
    delete [] app;
   }
 }
 void clearPtrs()
 {
  for (int i=0;i <max; i++)
   app[i]=NULL;
 }
 void reset()
 {
  clearPtrs();
  count=0;
 }
 int extend()
 {
  Appointment **tmp;
  
  //  printf("extend APL\n\n\n");
  tmp = new (Appointment *) [max +64];
  if(tmp == NULL)
   return false;
  if(app != NULL)
   {
    memcpy(tmp,app,sizeof(Appointment *)*max);
    clearPtrs();
    delete [] app;
   }
  app  = tmp;
  max += 64;
  return true;
 }
 int add(Appointment *a)
 {
  if(count>=max)
   if(! extend())
    return false;

  app[count] =a;
  count++;
  return true;
 }

 void remove(Appointment *a)
 {
  int ptr=-1;
  for(int i=0;i<count ; i++)
   if(app[i] == a)
    ptr = i;

  if(ptr>=0)
   {
    memmove(&app[ptr],&app[ptr+1],sizeof(Appointment *) * (count -ptr -1));
    count--;
   }
  sortSize=-1;
 }
 void sort()
 {
  qsort(app,count, sizeof(Appointment *),AppointmentPtrList::compareByTimes);
  sortSize = count;
 }
 static int compareByTimes(const void * v1,const void * v2)
 {
  Appointment *app1,*app2;
  
  app1 = *(( Appointment **) v1);
  app2 = *(( Appointment **) v2);

  if (app1 ->start > app2->start)
   return 1;
  if (app1 ->start < app2->start)
   return -1;
  if (app1 ->stop  > app2->stop )
   return 1;
  if (app1 ->stop  < app2->stop )
   return -1;
  return 0;
 } 
 Appointment * get(int id)
 {
  for(int i=0;i<count; i++)
   if(app[i]->id ==  id)
    return app[i];
  return NULL;
 }
 Appointment * firstAfter (int from, int to)
 {
  if (app == NULL)
   return NULL;

  if(count != sortSize)
   sort();

  if(app[0]->stop  > from)
   {
    scanPtr=0;
    return(app[0]);
   }

  int p0,p1,p2;
  p0 = 0;
  p2 = count-1;
  if(app[p2]->stop  < from)
   {
    scanPtr=-1;
    return NULL;
   }

  do
   {
    p1 = (p0+p2) >>1;
    //    printf("p1=%3d/%8d vs %8d\n",p1,app[p1]->
    if(app[p1]->stop  <=from)
     p0=p1;
    if(app[p1]->stop  > from)
     p2=p1;
//     printf("P: %3d/%8d %3d/%8d\n\t%8d\n",p0,app[p0]->start,p2,app[p2]->start,from);
   }while(p2-p0>1);
  scanPtr =p2;

//   fprintf(fpl,"-> scanPtr=%d\n,",scanPtr);
//   fprintf(fpl,"sttart(%3d)=%8d / to=%8d\n",p2,app[p2]->start,to);
  if(app[p2]->start > to)
   {
//     fprintf(fpl,"\n!!!!!!!!!!!!!\nsttart(%3d)=%8d > to=%8d\n",p2,app[p2]->start,to);
    scanPtr=-1;
    return NULL;
   }

  return app[p2];
 }

 Appointment * firstRepeatAfter (int from,int to)
 {
  if (app == NULL)
   return NULL;

  if(count != sortSize)
   sort();

  if(app[0]->rep.until  > from)
   {
    scanPtr=0;
    return(app[0]);
   }

  int p0,p1,p2;
  p0 = 0;
  p2 = count-1;
  if(app[p2]->rep.until  < from)
   {
    scanPtr=-1;
    return NULL;
   }

  do
   {
    p1 = (p0+p2) >>1;
    if(app[p1]->rep.until  <from)
     p0=p1;
    if(app[p1]->rep.until  > from)
     p2=p1;
   }while(p2-p0>1);
  scanPtr =p2;

  if(app[p2]->start > to)
   {
    scanPtr=-1;
    return NULL;
   }

  return app[p2];
 }
 Appointment * nextBefore(int tim)
 {
  if(scanPtr<0)
   return NULL;
  
  scanPtr++;
  if(scanPtr >= count)
   return NULL;

  if(app[scanPtr]->start < tim)
   return app[scanPtr];
  
  scanPtr=-1;
  return NULL;
 }
};

class AppointmentInstance 
{
public:
 Appointment *app;
 time_t start;
 time_t stop;
 int wday;
 int wdayMask;
 
 AppointmentInstance()
 {
  app=NULL;
  start=0;
  stop=0;
  wday =-1;
  wdayMask =0;
 }

 AppointmentInstance(Appointment *a)
 {
  app=a;
  start=0;
  stop=0;
  wday =-1;
  wdayMask =0;
 }

 
 void set(Appointment *a)
 {
  app   = a;
  start = a->start;
  stop  = a->stop;
  wday =-1;
  wdayMask =0;
 }
 void set(AppointmentInstance *ai)
 {
  app   = ai->app;;
  start = ai->start;
  stop  = ai->stop;
  wday  = ai->wday;
  wdayMask = ai->wdayMask;
 }

 int setFirstAfter( time_t from,time_t to)  // asumption tim is always midnight
 {
  struct tm *lt,*st,buf;
  int count;
  start = app->start;
  stop  = app->stop;
  switch (app->rep.type)
   {
   case REPEAT_TYPE_NONE: 
    return true;
    break;
   case REPEAT_TYPE_DAY: 
    {
     int diff = stop - start;

     st = localtime(&start);
     memcpy(&buf,st,sizeof(struct tm));
     lt = localtime(&from);
     lt->tm_hour = buf.tm_hour;
     lt->tm_min  = buf.tm_min;
     lt->tm_sec  = buf.tm_sec;
     start = mktime(lt);
     count = ((int) floor( (double)(start - app->start)/SECONDS_PER_DAY) ) % app->rep.intervall;
     if(count != 0)
      start += (app->rep.intervall- count) * SECONDS_PER_DAY;

     stop  = start+diff;
    }
    break;
   case REPEAT_TYPE_WEEK:    // Fixme fast week if only the dayflags for the original day is set
    {
     int diff = stop - start;
     int weekId;
     char tx[4][64];

     if( ( app->rep.dayFlags & 0x7F) == 0)
      return false;

//       strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//       strftime(tx[1],63,"%a %y-%m-%d %H:%M",localtime(&app->rep.refStart));
//       strftime(tx[2],63,"%a %y-%m-%d %H:%M",localtime(&from));
//       strftime(tx[3],63,"%a %y-%m-%d %H:%M",localtime(&to));
     
//       printf("search first instance of %4d %s \n",app->id,app->title);
//       printf("\t\tstart=%20s /%20s = %8d / %8d\n",tx[0],tx[1],start,app->rep.refStart);
//       printf("\t\tfrom=%20s /%8d  to %20s /%8d\n",tx[2],from,tx[3],to);
     
     st = localtime(&start);  // get the time struct for the start-instance of the appointment.
     memcpy(&buf,st,sizeof(struct tm));
     lt = localtime(&from);   // get the time strcut of start of the selction
     lt->tm_hour = buf.tm_hour; // copy the time into 
     lt->tm_min  = buf.tm_min;
     lt->tm_sec  = buf.tm_sec;
     wdayMask =weekDayFlagByIndex[lt->tm_wday];
     wday     = (lt->tm_wday+6) %7;

     start = mktime(lt);   // set thgis as new start of this instance

     weekId = ((int) floor( (double)(start - app->rep.refStart)/SECONDS_PER_WEEK) ) % app->rep.intervall;
//       strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//       printf("\t\t1. start = %8d/%20s -> wday=%d/%02X  weekId=%d intervall=%d\n",start,tx[0],wday,wdayMask,weekId,app->rep.intervall);

     if(weekId != 0 )  // if we are not on a 'rep.intervall'-th week after refStart, skip to beggining of next Week
      {
       start   += (7-wday) * SECONDS_PER_DAY;
       weekId   = (weekId+1) % app->rep.intervall;
       wdayMask = MONDAY;
       wday     = 0;
      }
//       strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//       printf("\t\t2. start = %8d/%20s  -> wday=%d/%02X  weekId=%d intervall=%d\n",start,tx[0],wday,wdayMask,weekId,app->rep.intervall);

     
     
     while(start < to)
      {
       if(weekId == 0)
	{
	 while( (app->rep.dayFlags & wdayMask) == 0)
	  {
	   start+=SECONDS_PER_DAY;
	   wdayMask = wdayMask <<1;
	   wday ++;
	   if(wdayMask > SUNDAY)
	    {
	     wdayMask = MONDAY;
	     wday     = 0;
	     weekId = ((int) floor( (double)(start - app->rep.refStart)/SECONDS_PER_WEEK) ) % app->rep.intervall;
	     break;
	    }
	  }
	 if(weekId==0 &&  (app->rep.dayFlags & wdayMask) != 0)
	  break;
	}
       else
	{
	 start += (app->rep.intervall - weekId) * SECONDS_PER_WEEK;
	 weekId = 0;
	}
//         strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//         printf("\t\t3. start = %8d/%20s  -> wday=%d/%02X  weekId=%d intervall=%d\n",start,tx[0],wday,wdayMask,weekId,app->rep.intervall);
      }
//       strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//       printf("\t\tFOUND start=%8d = %20s wday=%1d /%02X\n",start,tx[0],wday,wdayMask);
     stop  = start + diff;
    }
    break;
   case REPEAT_TYPE_MONTH: 
    {
     int diff = stop - start;

     st = localtime(&start);
     memcpy(&buf,st,sizeof(struct tm));
     lt = localtime(&from);
     if (lt->tm_mday > buf.tm_mday)
      {
       lt->tm_mon ++;
       if (lt->tm_mon>11)
	{
	 lt->tm_mon =0;
	 lt->tm_year++;
	}
      }
     count = ((lt->tm_mon-buf.tm_mon) + 12 * (lt->tm_year - buf.tm_year)) % app->rep.intervall;
     if(count != 0)
      {
       lt->tm_mon += (app->rep.intervall - count);
       while(lt->tm_mon > 11)
	{
	 lt->tm_year ++;
	 lt->tm_mon -= 12;
	}
      }

     lt->tm_mday  = buf.tm_mday;
     lt->tm_hour = buf.tm_hour;
     lt->tm_min  = buf.tm_min;
     lt->tm_sec  = buf.tm_sec;
     start = mktime(lt);
     stop  =  start +diff;
    }
    break;
   case REPEAT_TYPE_YEAR: 
    {
     int diff = stop - start;
     int year,refYear;

     lt = localtime(&from);
     year = lt->tm_year;
     st = localtime(&start);

     refYear =  st->tm_year;
     st->tm_year = year;
     start =  mktime(st);
     if(start <from)
      {
       st->tm_year++;
       start =  mktime(st);
      }
     count =  (st->tm_year - refYear) % app->rep.intervall;
     if( count !=0)
      {
       st->tm_year += (app->rep.intervall-count);
       start =  mktime(st);
      }
     stop  =  start +diff;
    }
    break;
   case REPEAT_TYPE_MONTH_BY_DAY: 
    {
     int c;
     int diff = stop - start;
     char tx[64];

     st = localtime(&start);
//      printf("start: %d-%2d-%2d\n",st->tm_year,st->tm_mon,st->tm_mday);
     memcpy(&buf,st,sizeof(struct tm));
     lt = localtime(&from);
     count = ((lt->tm_mon-buf.tm_mon) + 12 * (lt->tm_year - buf.tm_year)) % app->rep.intervall;
//      printf("from : %d-%2d-%2d -> count=%d\n",lt->tm_year,lt->tm_mon,lt->tm_mday,count);
     if ( count != 0)
      lt->tm_mon += (app->rep.intervall - count);

     do 
      {
       lt->tm_mday = app->rep.weekInMonth*7+1;
       lt->tm_hour = buf.tm_hour;
       lt->tm_min  = buf.tm_min;
       lt->tm_sec  = buf.tm_sec;
       start  = mktime(lt);
       lt     = localtime(&start);
       wdayMask =  weekDayFlagByIndex[lt->tm_wday];

       c=0;
       while ( (app->rep.dayFlags & wdayMask) == 0 && c<7)
	{
	 start += SECONDS_PER_DAY;
	 wdayMask =wdayMask <<1;
	 if(wdayMask > SUNDAY)
	  {
	   wdayMask = MONDAY;
	  }
	 c++;
	}
       //       printf("%d cycles\n",c);
       if (c>= 7)
	return false;
       stop =start+diff;
       if(stop <from)
	{
	 //	 printf("\t\t\t\t\t\t trying next month (%d > from=%d)\n",stop,from);
	 lt->tm_mon += app->rep.intervall;
	 while   (lt->tm_mon>11)
	  {
	   lt->tm_mon -= 12;
	   lt->tm_year++;
	  }
	}
     }while(stop < from);
//     stop  =  start +diff;
//     printf(" ->  start =%8d\n",start);
    }
    break;
   }
  
  for(int i=0;i<app->rep.exceptionCount; i++)  // FIXME optimise by caching the ptr to the last used except.
   if(app->rep.exceptions[i] == start)                //       and make exceptions beeing sorted
    return(setNextBefore(to));

//   char tx[3][64];
//   strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//   strftime(tx[1],63,"%a %y-%m-%d %H:%M",localtime(&app->rep.until));
//   strftime(tx[2],63,"%a %y-%m-%d %H:%M",localtime(&to));
//   printf("\t\tfinaal Check: start=%8d until=%8d to=%8d\n",start,app->rep.until,to);
//   printf("\t\t              %20s %20s %20s\n",tx[0],tx[1],tx[2]);

  if(start > app->rep.until)
   return false;

  if(start >to)
   return false;

  return true;
 }

 int setNextBefore(int tim)
 {
  switch (app->rep.type)
   {
   case REPEAT_TYPE_NONE: return false; break;
   case REPEAT_TYPE_DAY: 
    {
     start += SECONDS_PER_DAY * app->rep.intervall;
     stop  += SECONDS_PER_DAY * app->rep.intervall;
    }
    break;
   case REPEAT_TYPE_WEEK: 
    {
     int diff = start -stop;
     char tx[2][64];
     if( ( app->rep.dayFlags & 0x7F) == 0)
      return false;

//      printf("\t\tlooking for next of %s\n",app->title);
     do
      {
       wdayMask = wdayMask <<1;
       wday ++;
       if(wdayMask > SUNDAY)
	{
	 wdayMask = MONDAY;
	 wday = 0;
	 start += (app->rep.intervall-1) * SECONDS_PER_WEEK + SECONDS_PER_DAY;
	}
       else
	start+=SECONDS_PER_DAY;
//        strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//        printf("\t\tcheking start=%8d = %20s wday=%1d wMask=%02X flags=%02X\n",start,tx[0],wday,wdayMask,app->rep.dayFlags);
      }while( (app->rep.dayFlags & wdayMask) == 0);
     //     start += offset;
//       strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime(&start));
//       printf("\t\tFOUND start=%8d = %20s\n",start,tx[0]);
     stop  = start +diff;
    }
    break;
   case REPEAT_TYPE_MONTH: 
    {
     struct tm *lt;
     int diff = stop - start;

     lt = localtime(&start);
     lt->tm_mon += app->rep.intervall;
     while (lt->tm_mon>11)
      {
       lt->tm_mon -= 12;
       lt->tm_year++;
      }
     start = mktime(lt);
     stop +=  start +diff;
    }
    break;
   case REPEAT_TYPE_YEAR: 
    {
     struct tm *lt;
     int diff = stop - start;

     lt = localtime(&start);
     lt->tm_year +=  app->rep.intervall;
     start = mktime(lt);
     stop +=  start +diff;
    }
    break;
   case REPEAT_TYPE_MONTH_BY_DAY: 
    {
     int c;
     struct tm *lt;
     int diff = stop - start;

     lt = localtime(&start);
     lt->tm_mon += app->rep.intervall;
     while (lt->tm_mon>11)
      {
       lt->tm_mon -=12;
       lt->tm_year++;
      }
     lt->tm_mday = app->rep.weekInMonth*7+1;
     start  = mktime(lt);
     lt     = localtime(&start);
     wdayMask = weekDayFlagByIndex[lt->tm_wday];
     c=0;
     while ( (app->rep.dayFlags & wdayMask) == 0 && c<7)
      {
       start += SECONDS_PER_DAY;
       wdayMask <<1;
       if(wdayMask > SUNDAY)
	wdayMask = MONDAY;
       c++;
      }
     if (c>= 7)
      return false;
     stop = start +diff;
    }
    break;
   }
  
  for(int i=0;i<app->rep.exceptionCount; i++)  // FIXME optimise by caching the ptr to the last used except.
   if(app->rep.exceptions[i] == start)                //       and make exceptions beeing sorted
    return(setNextBefore(tim));

  if(start >tim)
   return false;

  if(start > app->rep.until)
   return false;

  return true;
 }




 void print(FILE *fp)
 {
  char tx[8][64],*dt,*t;
  struct tm *t0,*t1,*at;
  //  int l =strlen(app->title);

  t0 = localtime(&start);
  strftime(tx[0],63,"%Y-%m-%d",t0);
  strftime(tx[2],63,"%H:%M",t0);
  t1 = localtime(&stop);
  strftime(tx[1],63,"%Y-%m-%d",t1);
  strftime(tx[3],63,"%H:%M",t1);

  printf("%10s - %10s\n",tx[0],tx[1]);
  printf("%10s - %10s\n",tx[2],tx[3],tx[4],tx[5]);


  if(app->alarm[0]>=0)
   {
    at = localtime(&app->alarmTime[0]);
    strftime(tx[0],20,"%Y-%m-%d %H:%M",at);
    printf("Alarm: %20s\n",tx[0]);
   }

  dt= app->title;
  while(dt != NULL)
   {
    strncpy(tx[4],dt,28);
    tx[4][28]='\0';
    if(strchr(tx[4],'\n') != NULL)
     {
      *t='\0';
      dt = strchr(dt,'\n')+1;
      if(dt != NULL)
       dt++;
      if(*dt == '\0')
       dt=NULL;
     }
    else
     {
      if(strlen(dt)>28)
       dt+=28;
      else
       dt = NULL;
     }
    tx [4][28]='\0';
    printf("%-28s\n",tx[4]);
   }  
  printf("----------------------------\n");
 }




};

class AppointmentInstanceList
{
public:
 AppointmentInstance **app;
 int count;
 int max;

 AppointmentInstanceList()
 {
  app   = NULL;
  count = 0;
  max   = 0;
 }

 ~AppointmentInstanceList()
 {
  if( app != NULL)
   {
    reset();
    delete [] app;
   }
 }
 void clearPtrs()
 {
  if(app != NULL)
   for (int i=0;i <max; i++)
    app[i]=NULL;
 }
 void reset()
 {
  clearPtrs();
  count=0;
 }

 int extend()
 {
  AppointmentInstance **tmp;
  
  //  printf("extend AIL\n");
  tmp = new (AppointmentInstance *) [max +64];
  if(tmp == NULL)
   return false;
  if(app != NULL)
   {
    memcpy(tmp,app,sizeof(AppointmentInstance *)*max);
    clearPtrs();
    delete [] app;
   }
  app  = tmp;
  max += 64;
  return true;
 }
 int add(Appointment *a)
 {
  if(count>=max)
   if(! extend())
    return false;

  app[count] = new AppointmentInstance ;
  app[count]->set(a);
//   printf("add APP %p %d %d (%s)  on listpos %d : %d %d %p (%d %d %s)\n",
// 	 a,a->start,a->stop,a->title,
// 	 count,app[count]->start,app[count]->stop,app[count]->app,
// 	 app[count]->app->start,app[count]->app->stop,app[count]->app->title);
  count++;
  return true;
 }
 int add(AppointmentInstance *a)
 {
  if(count>=max)
   if(! extend())
    return false;

  //  printf("add AI %3d: %d %d (<%d) %s\n",a->app->id,a->start,a->stop,a->app->rep.until,a->app->title);
  app[count] = new AppointmentInstance ;
  app[count]->set(a);
  count++;
  return true;
 }
 void sort()
 {
  qsort(app,count, sizeof(AppointmentInstance *),AppointmentInstanceList::compareByTimes);
  //  sortSize = count;
 }
 static int compareByTimes(const void * v1,const void * v2)
 {
  AppointmentInstance *app1,*app2;
  
  app1 = *(( AppointmentInstance **) v1);
  app2 = *(( AppointmentInstance **) v2);

  if (app1 ->start > app2->start)
   return 1;
  if (app1 ->start < app2->start)
   return -1;
  if (app1 ->stop  > app2->stop )
   return 1;
  if (app1 ->stop  < app2->stop )
   return -1;
  return 0;
 } 
};

class CalendarFilter
{
public:
 int showPrivate;
 int showHidden;
 int showCanceled;
 int showCategory;
 int showLocation;
 int from;
 int to;
 
 CalendarFilter()
 {
  showPrivate   = true;
  showHidden    = false;
  showCanceled  = false;
  showCategory  = CATEGORY_ALL;
  showLocation  = LOCATION_ALL;
  from          = 0;
  to            = 0;
 }
 void set(int p, int h, int c)
 {
  showPrivate   = p;
  showHidden    = h;
  showCanceled  = c;
 }
 void set(int p, int h, int c,int cat, int loc)
 {
  showPrivate   = p;
  showHidden    = h;
  showCanceled  = c;
  showCategory  = cat;
  showLocation  = loc;
 }
 void setIntervall(int t0,int t1)
 {
  from = t0;
  to   = t1;
 }
 int filter(Appointment *app)
 {
  if(app->priv)
   if(!showPrivate)
    return false;
  if(app->hidden)
   if(!showHidden)
    return false;
  if(app->canceled)
   if(!showCanceled)
    return false;
  
  if(showCategory != CATEGORY_ALL)
   if(showCategory != app->category)
    return false;

//   if(showLocation != LOCATION_ALL)
//    if(showLocation != app->location)
//     return false;

  return true;
 }
 int filter2(Appointment *app)
 {
  if(app->stop<from || app->start>to)
   return false;
  
  return (filter(app));
 }
};


void updateAlarmRepeatAppointment(Appointment *app,int now);


class Calendar
{
public:
 Appointment current;
 AppointmentPtrList all;
 AppointmentPtrList apps;
 AppointmentPtrList repApps;
 AppointmentInstanceList selection;
 int nextID;

 Calendar()
 {
  nextID =0;
 }

 void add2Lists(Appointment *app)
 {
  if(app != NULL)
   {
    //    printf("add app id=%4d to all\n",app->id);
    all.add(app);
    if(app->rep.type != REPEAT_TYPE_NONE)
     {
      //      printf("add app id=%4d to repapps\n",app->id);
      repApps.add(app);
      repApps.sortSize=0;
     }
    else
     {
      apps.add(app);
      apps.sortSize=0;
     //      printf("add app id=%4d to apps -> count =%d\n",app->id,apps.count);
     }
   }
 }

 void remove(Appointment *app)
 {
  if(app->rep.type != REPEAT_TYPE_NONE)
   repApps.remove(app);
  else
   apps.remove(app);
  all.remove(app);
  deleteFromDB(app->DBkey);
  delete app;
 }

 void add(int key, char *dbline,int len)
 {
  Appointment *app = new Appointment(nextID,key,dbline,len);
  add2Lists(app);
  nextID++;
 }

 Appointment * add(Appointment *ref)
 {
  Appointment *app = new Appointment(nextID,time(NULL),ref);
  add2Lists(app);
  nextID++;
  return(app);
 }

 void modify(Appointment *ref)
 {
  Appointment *app;

  ref->createDBline();
  //  printf("Modify on id %d\n",ref->id);
  if(ref->id <0)
   {
    app = add(ref);
   }
  else
   {
    app = all.get(ref->id);
    //    printf("found app=%p\n",app);
    if(app == NULL)
     {
      //      printf("create new (id was %d, // %d %d)\n",ref->id,ref->start,ref->stop);
      app = add(ref);
     }
    else
     {
      //      printf("\nUPDATE id=%d\n\n",ref->id);
      app->update(ref);
      if(app->rep.type ==  REPEAT_TYPE_NONE && ref->rep.type ==  REPEAT_TYPE_NONE)
       apps.sortSize=0;
      else if (app->rep.type !=  REPEAT_TYPE_NONE && ref->rep.type !=  REPEAT_TYPE_NONE)
       repApps.sortSize =0;
      else if (app->rep.type ==  REPEAT_TYPE_NONE && ref->rep.type !=  REPEAT_TYPE_NONE)
       {
	apps.remove(app);
	repApps.add(app);
       }
      else if (app->rep.type !=  REPEAT_TYPE_NONE && ref->rep.type ==  REPEAT_TYPE_NONE)
       {
	repApps.remove(app);
	apps.add(app);
       }
     }
   }
  //  printf ("start At job\n");

  if(app->alarmTime[0] >0 ||  app->alarmTime[1] >0 ||app->alarmTime[2] >0 ||app->alarmTime[3] >0)
   {
    startAtJob();
    atJobCleaner(); // clean up other already start at job and keep only the one scheuled next 
   }
  //  printf ("start At job done\n");
 }


 AppointmentInstanceList * select(CalendarFilter *filter)
 {
  Appointment *app;
  AppointmentInstance appInst;
  char tx[2][64];
  int from = filter->from;
  int to = filter->to;

#ifdef DEBUG
  strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime((const time_t *) &from));
  strftime(tx[1],63,"%a %y-%m-%d %H:%M",localtime((const time_t *) &to));
  printf("select from %8d/%20s to %8d/%20s  flags=%1d/%1d/%1d  cat=%2d loc=%2d\n",from,tx[0],to,tx[1],
	 filter->showPrivate,filter->showHidden,filter->showCanceled,filter->showCategory,filter->showLocation);
  //   fprintf(fpl,"\n----------------------\nselect from %8d/%20s to %8d/%20s\n\t flags=%1d/%1d/%1d\n\t  cat=%2d loc=%2d\n",from,tx[0],to,tx[1],
  // 	  filter->showPrivate,filter->showHidden,filter->showCanceled,filter->showCategory,filter->showLocation);
#endif

  selection.reset();

  app = apps.firstAfter(from,to);


#ifdef DEBUG
  for(int i=0;i<apps.count; i++)
   //   fprintf(fpl,"APPS(%3d): %8d - %8d %s\n",i,apps.app[i]->start,apps.app[i]->stop,apps.app[i]->title);
   printf("APPS(%3d, id=%4d): %8d - %8d %s\n",i,apps.app[i]->id,apps.app[i]->start,apps.app[i]->stop,apps.app[i]->title);

  //  fprintf(fpl,"first: %p\n",app);
  printf("first: %p\n",app);
#endif
  while(app != NULL)
   {
#ifdef DEBUG
    fprintf(fpl,"Checking app %30s:\n %8d - %8d within %8d- %8d? \n",app->title,app->start,app->stop,from,to);
#endif
    if(filter->filter2(app))
     selection.add(app);
    app = apps.nextBefore(to);
   }

  app = repApps.firstRepeatAfter(from,to);
  while(app != NULL)
   {
#ifdef DEBUG
    strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime((const time_t *) &app->start));
    printf("Checking rapp %3d %30s : %8d/%20s - %8d within %8d- %8d\n",app->id,app->title,app->start,tx[0],app->stop,from,to);
#endif
    if(filter->filter(app))
     {
      //      printf("passed filter\n");
      appInst.set(app);
      if(appInst.setFirstAfter(from,to))
       do
	{
#ifdef DEBUG
	 strftime(tx[0],63,"%a %y-%m-%d %H:%M",localtime((const time_t *) &appInst.start));
	 printf("\tcheck instance @ %8d/%20s\n",appInst.start,tx[0]);
#endif
	 if(appInst.stop>=from &&  appInst.start<=to)
	  {
#ifdef DEBUG
	   printf("\t\tadd instance \n");
#endif
	   selection.add(&appInst);
	  }
	}while(appInst.setNextBefore(to));
     }
    app = repApps.nextBefore(to);
   }
  
  selection.sort();
  return(&selection);
 }

 void updateAlarm()
 {
  int tim = time(NULL);
  //  time_t atim[4];

  createAlarmDB();
  for(int i=0; i<apps.count ; i++)
   if(!apps.app[i]->canceled)
    apps.app[i]->updateAlarm(tim);

  for(int i=0; i<repApps.count ; i++)
   if(!repApps.app[i]->canceled)
    updateAlarmRepeatAppointment(repApps.app[i],tim);
 }
};

# endif
