/* File: calTimeLine.h
 *
 * Time-stamp: <12-May-2003 22:50:02 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: me
 *
 * Description: 
 * 
 */
# ifndef CALTIMELINE_H_INCLUDED
# define CALTIMELINE_H_INCLUDED


class calTimeLine 
{
public:
 char *txt;
 char label[16];
 int tim;
 int row;
 int end;
 int aid;

 calTimeLine()
 {
  txt=NULL;
  label[0]='\0';
  end =0;
  row=0;
  aid =-1;
 }
 ~calTimeLine()
 {
  txt=NULL;
 }

 void init(int h, int m)
 {
  tim = (h<<8)+m;

  sprintf(label,"%2d:%02d",h,m);
  //  printf("\t\t\t\t\t\t\t init line %p: %6s (tim=%d)\n",this,label,tim);
 }
 void init(int h, int m,int tm)
 {
  tim = tm;
  sprintf(label,"%2d:%02d",h,m);
  //  printf("\t\t\t\t\t\t\t init line %p: %6s @%8d\n",this,label,tim);
 }
 void init(int h, int m,int tm, char *tx, int r,int e,int a)
 {
  tim = tm;
  sprintf(label,"%2d:%02d",h,m);
  txt=tx;
  row=r;
  end =e;
  aid =a;
  printf("\t\t\t\t\t\t\t init line %p: %6s @%8d aid=%d txt=%p /%s/\n",this,label,tim,aid,txt,txt);
 }

 
 void init(timeDef *td)
 {
  //  tim = (h<<8)+m;
  tim= td->tim;
  sprintf(label,"%2d:%02d",td->hour,td->min);
  //  printf("\t\t\t\t\t\t\t init line %p: %6s (tim=%d)\n",this,label,tim);
 }
 void init(timeDef *td, timeDef *evening)
 {
  tim = td->tim;
  //  printf("t1=%8d vs evening=%8d for %s\n",td->tim,evening->tim);

  if(td->tim==evening->tim+1)
   sprintf(label,"%2d:%02d",td->hour+24,td->min);
  else if(td->tim>evening->tim)
   sprintf(label,"%2d.%2d",td->day,td->mon);
  else
   sprintf(label,"%2d:%02d",td->hour,td->min);
  //  sprintf(label,"%2d:%02d",h,m);
  //  printf("\t\t\t\t\t\t\t init line %p: %6s @%8d\n",this,label,tim);
 }
 void init(timeDef *t0, timeDef *t1, timeDef *morning, char *tx, int r,int a,int withLabel)
 {
  tim = t0->tim;
  //  printf("ADD %s at %2d.%2d, %2d:%02d\n",tx,t0->day,t0->mon,t0->hour,t0->min);
  if(withLabel)
   {
    //    printf("t0=%8d vs morning=%8d for %s\n",t0->tim,morning->tim,tx);
    if(t0->tim<morning->tim)
     sprintf(label,"%2d.%2d",t0->day,t0->mon);
    else
     sprintf(label,"%2d:%02d",t0->hour,t0->min);
   }
   
  txt=tx;
  row=r;
  end =t1->tim;
  aid =a;
 }
};

class calTimeLineList
{
public:
 calTimeLine *line;
 int anz;
 int max;
 int rowEnd[16];
 int maxRow;
 int textLines;

 calTimeLineList()
 {
  max = 16;
  line = new calTimeLine [max] ;
  anz =0;
  maxRow=0;
  textLines=0;
  for(int i=0;i<16; i++)
   rowEnd[i]=0;
 }
 
 void reset()
 {
  maxRow=0;
  delete [] line;
  max = 16;
  line = new calTimeLine [max] ;
  anz =0;
  for(int i=0;i<16; i++)
   rowEnd[i]=0;
  for(int i=0; i<max ;i++)
   line->txt=NULL;
 }

 void extend ()
 {
  calTimeLine *tmp;

//   printf("EXTEND:\n");
  
//   for(int i=0;i<max; i++)
//    printf("Line %2d: %p %12p %s %5d %2d \n",i,&line[i],line[i].txt,line[i].label,line[i].tim,line[i].aid);

  tmp = new calTimeLine [max+8];
  memcpy(tmp,line,sizeof(calTimeLine)*max);
  for(int l=0;l<max; l++)
   line[l].txt =NULL;

//   for(int i=0;i<max; i++)
//    printf("Line %2d: %p %12p %s %5d %2d \n",i,&line[i],line[i].txt,line[i].label,line[i].tim,line[i].aid);

  delete [] line;

  line=tmp;
  max+= 8;
//   for(int i=0;i<max; i++)
//    printf("Line %2d: %p %12p %s %5d %2d \n",i,&line[i],line[i].txt,line[i].label,line[i].tim,line[i].aid);
 }

 int findFirst(int tim, int l)
 {
  for(int t=l+1;t<anz; t++)
   if(line[t].tim == tim)
    return t;
  return -1;
 }

 int find(int tm)
 {
  for(int t=0;t<anz; t++)
   {
    //    printf("find line with tim=%8d  : is it %2d = %8d?\n",tm,t,line[t].tim);
    if(line[t].tim == tm)
     return t;
   }
  return -1;
 }

 void _add(int h, int m)
 {
  if(anz >=max)
   extend();

  line[anz].init(h,m);
  anz++;
 }
 
//  void add(int h, int m)
//  {
//   int tim = (h<<8) +m;
//   if(find(tim)<0)
//    {
//     if(anz >=max)
//      extend();
//     line[anz].init(h,m);
//     anz++;
//    }
//  }
 void add(int h, int m, int tim)
 {
  int l;
  if( (l=find(tim))<0)
   {
    //    printf("\t\t\t\t\t\t\tNew line %d\n",anz);
    if(anz >=max)
     extend();
    line[anz].init(h,m,tim);
    anz++;
   }
//   else
//    {
//     printf("line %d /%d %s %s/ already has %d %d\n",l,line[l].tim,line[l].label,line[l].txt,h,m);
//    }
 }


 void addJournal(char *txt,int aid)
 {
  int tim0 =-256+aid;
  char *tx,*t,*t0;
  timeDef td;
  td.tim = aid*60;
  td.set();

  t0 =txt;
  while(strlen(t0) >25)
   {
    tx = new char[32];
    
    t = t0 +25;
    while(  t >t0  && *t != ' ')
     t--;
    if(t>t0)
     {
      int d = t-t0;
      strncpy(tx,t0,d);
      tx[d] ='\0';
      t0 =t+1;
     }
    else
     {
      strncpy(tx,t0,25);
      tx[25] ='\0';
      t0 =t0+25;
     }
    //    add(0,0,tim0,tx,0,-1,aid);
    add(&td,&td,&td,tx,0,aid,false);
   }
  add(&td,&td,&td,t0,0,aid,false);
  //  add(-1,aid,tim0,t0,0,-1,aid);
 }


 void add(int h0, int m0,int h1,int m1 ,char *txt,int aid)
 {
  int tim0 = (h0<<8) +m0;
  int tim1 = (h1<<8) +m1;
  char *tx,*t,*t0;
  int first=true,sl;

  int row=15;
  while(row>=0 && rowEnd[row]<=tim0)
   row--;
  row++;
  if(row>15)
   row=15;

  printf("LINE: %s /%d/%d/ /%d/%d/\n",txt,h0,m0,h1,m1);
  
  //  printf("txt='%s' -> %d\n",txt,strlen(txt));
  if(strlen(txt) >25)
   {
    t0 =txt;
    while(strlen(t0) >25)
     {
      tx = new char[32];

      t = t0 +25;
      while(  t >t0  && *t != ' ')
       t--;
      if(t>t0)
       {
	int d = t-t0;
	strncpy(tx,t0,d);
	tx[d] ='\0';
	t0 =t+1;
       }
      else
       {
      	strncpy(tx,t0,25);
	tx[25] ='\0';
	t0 =t0+25;
       }
      if(first)
       add(h0,m0,tim0,tx,row,tim1,aid);
      else
       add(h0,m0,tim0,tx,row,-1,aid);
      first=false;
     }
    add(h0,m0,tim0,t0,row,0,aid);

   }
  else
   add(h0,m0,tim0,txt,row,tim1,aid);

  printf("END: %d %d -> %d\n",h1,m1,tim1);
  add(h1,m1,tim1);
  rowEnd[row]=tim1;
 }


 void add(timeDef *start,timeDef *stop, timeDef *morning,timeDef *evening,char *txt,int aid)
 {
//   int tim0 = (h0<<8) +m0;
//   int tim1 = (h1<<8) +m1;
  char *tx,*t,*t0;
  int first=true,sl;

  int row=15;
  while(row>=0 && rowEnd[row]<=start->tim)
   row--;
  row++;
  if(row>15)
   row=15;

  //  printf("LINE: %s /%d/%d/ /%d/%d/\n",txt,h0,m0,h1,m1);
  
  //  printf("txt='%s' -> %d\n",txt,strlen(txt));
  if(strlen(txt) >25)
   {
    t0 =txt;
    while(strlen(t0) >25)
     {
      tx = new char[32];

      t = t0 +25;
      while(  t >t0  && *t != ' ')
       t--;
      if(t>t0)
       {
	int d = t-t0;
	strncpy(tx,t0,d);
	tx[d] ='\0';
	t0 =t+1;
       }
      else
       {
      	strncpy(tx,t0,25);
	tx[25] ='\0';
	t0 =t0+25;
       }
      if(first)
       //     add(h0,m0,tim0,tx,row,tim1,aid);
       add(start,stop,morning,tx,row,aid,true);
      else
       //     add(h0,m0,tim0,tx,row,-1,aid);
       add(start,stop,morning,tx,row,aid,false); 
     first=false;
     }
    add(start,stop,morning,t0,row,aid,false);
       //    add(h0,m0,tim0,t0,row,0,aid);

   }
  else
   add(start,stop,morning,txt,row,aid,true);
  //   add(h0,m0,tim0,txt,row,tim1,aid);

  //  printf("END: %d %d -> %d\n",h1,m1,tim1);
  //  add(h1,m1,tim1);
  add(stop,evening);
  rowEnd[row]=stop->tim;
 }



 void add(timeDef *start, timeDef *stop, timeDef *morning ,char *txt,int row,int aid,int withLabel)
 {
  int p;
  p=find(start->tim);
//   printf("%s\t\t\t\t\t\t\tfind(%8d) =%d\n",txt,start->tim,p);

  if( (p=find(start->tim)) <0)
   {
//     printf("\t\ttnew line %d: %s %d:%02d %d\n",anz,txt,start->hour,start->min,withLabel);
    if(anz >=max)
     extend();
    //    line[anz].init(h,m,tim,txt,row,end,aid);
    line[anz].init(start,stop,morning,txt,row,aid,withLabel);
//     if(end<0)
//      line[anz].label[0]='\0';
    anz++;
   } 
  else
   {
    if (line[p].txt != NULL)
     {
      //      printf("\t\t\t\t\t\t\tnew line %d\n",anz);
//       printf("\t\ttnew line %d: %s %d:%02d %d\n",anz,txt,start->hour,start->min,withLabel);
      if(anz >=max)
       extend();
      //  line[anz].init(h,m,tim,txt,row,end,aid);
      line[anz].init(start,stop,morning,txt,row,aid,withLabel);
//       if(end<0)
//      line[anz].label[0]='\0';
      anz++;
     }
    else
     {
//       printf("\t\ttfill line %d: %s %d:%02d %d\n",p,txt,start->hour,start->min,withLabel);
      line[p].init(start,stop,morning,txt,row,aid,withLabel);
//       line[p].init(h,m,tim,txt,row,end,aid);
//       if(end<0)
//        line[p].label[0]='\0';
     }
   }

  if(row > maxRow)
   maxRow=row;
  textLines++;
 }

 void add(timeDef *stop,timeDef *evening)
 {
  int l;
  if( (l=find(stop->tim))<0)
   {
    //    printf("\t\t\t\t\t\t\tNew line %d\n",anz);
    if(anz >=max)
     extend();
    //    line[anz].init(h,m,tim);
    line[anz].init(stop,evening);
    anz++;
   }
//   else
//    {
//     printf("line %d /%d %s %s/ already has %d %d\n",l,line[l].tim,line[l].label,line[l].txt,h,m);
//    }
 }
 void add(timeDef *t)
 {
  int l;
  if( (l=find(t->tim))<0)
   {
    //    printf("\t\t\t\t\t\t\tNew line %d\n",anz);
    if(anz >=max)
     extend();
    line[anz].init(t);
    anz++;
   }
 }


 void add(int h, int m,int tim ,char *txt,int row,int end,int aid)
 {
  int p;
  p=find(tim);
  //  printf("\t\t\t\t\t\t\tfind(%8d) =%d  (end=%d)\n",tim,p,end);

  if( (p=find(tim)) <0)
   {
    //    printf("\t\t\t\t\t\t\tnew line %d\n",anz);
    if(anz >=max)
     extend();
    line[anz].init(h,m,tim,txt,row,end,aid);
    if(end<0)
     line[anz].label[0]='\0';
    anz++;
   } 
  else
   {
    if (line[p].txt != NULL)
     {
      //      printf("\t\t\t\t\t\t\tnew line %d\n",anz);
      if(anz >=max)
       extend();
      line[anz].init(h,m,tim,txt,row,end,aid);
    if(end<0)
     line[anz].label[0]='\0';
      anz++;
     }
    else
     {
      line[p].init(h,m,tim,txt,row,end,aid);
      if(end<0)
       line[p].label[0]='\0';
     }
   }

  if(row > maxRow)
   maxRow=row;
  textLines++;
 }

 void sort()
 {
  qsort(line,anz,sizeof(calTimeLine),calTimeLineList::compareEntries);
 }
 static int calTimeLineList::compareEntries(const void *v1,const void *v2)
 {
  int d;
  calTimeLine *e1 = (calTimeLine *) v1;
  calTimeLine *e2 = (calTimeLine *) v2;
  
  d = e1->tim - e2->tim;
  if(d != 0)
   return d;
  d = e1->row - e2->row;
  return d;
 }
};



# endif
