// File: db.cc
//
// Time-stamp: <01-Jun-2003 19:17:54 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: me
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>
#include <sys/types.h>
#include <limits.h>
#include <sys/fcntl.h>
#include <db1/db.h>
#include <errno.h>

#include "calendrian.h"
//#include "appointment.h"
char DBsep=0x1f,DBsep2=0x1e;
// char *skip2NextSep(char *t,char sep);
// int unsplit(char **tp,int max, char *s,char sep);
void writeDB(DB *pdbp,int key,char *content, int len);


char DBbuffer[DB_BUFFER_LEN];
int DBInputVersion;
static char *DBfile_base="schedule.dat";
static char *alarmFile_base="calendrian.alarms";
static char *DBfile =NULL;
static char *alarmFile = NULL;
AlarmList alarms;
int nextDBkey;

void initFileNames()
{
 char *home=getenv("HOME");
 int l = strlen(home);
 
 DBfile = new char [l+16];
 sprintf(DBfile,"%s/%s",home,DBfile_base);
 alarmFile = new char [l+20];
 sprintf(alarmFile,"%s/%s",home,alarmFile_base);
}

int readDB(char *file)
{
 DB *pdbp;
 DBT pkey, pcontent;
 int status;
 char kbuf[256],*t,buf2[256];
 char *tp[264];
 unsigned int *ky,kp;
 int key;

 if(DBfile==NULL)
  initFileNames();

  
 pdbp = dbopen(DBfile, O_RDONLY, 0664, DB_HASH, NULL);

 if(!pdbp) {
  //  printf("create new DBfile on %s\n",DBfile);
  pdbp = dbopen(DBfile, O_CREAT | O_RDWR, 0664, DB_HASH, NULL);
  if(!pdbp) {
   //   printf("error 1\n");
   exit(-1);
  }
  
  //                 123456789012345678901234567890
  strcpy(DBbuffer+2,"Schedule:schedule:0.11");
  DBbuffer[0] =0;
  DBbuffer[1] =0;
  writeDB(pdbp,-2,DBbuffer,24);
  pdbp->close(pdbp);
  return true;
 }

 ky=(unsigned int *) kbuf;
 memset(kbuf,0,255);
 *ky=0xFFFFFFFF;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 
 key=-2;
 *ky = swapEndianess32((unsigned int *) &key);
 int err = pdbp->get(pdbp,&pkey,&pcontent,0);
 strncpy(buf2,((char *)pcontent.data)+2,pcontent.size);
 t = buf2;
 t[pcontent.size-2]='\0';
 t=strchr(t,'.')+1;

 DBInputVersion = atoi(t);


 
 nextDBkey=0;

 status = pdbp->seq(pdbp, &pkey, &pcontent,R_CURSOR);
 for(int status = pdbp->seq(pdbp, &pkey, &pcontent, R_FIRST); 
     status == 0; 
     status = pdbp->seq(pdbp, &pkey, &pcontent, R_NEXT)) 
  {
   t =(char *)pcontent.data;
   if( ( t[0] & 4) == 4)
    {
     continue;
    }
   if( ( t[0] & 2) == 2)  // deleted entry
    {
     continue;
    }
   memset(kbuf,0,255);
   memcpy(kbuf,pkey.data,pkey.size);
   kbuf[pkey.size] ='\0';
    
   key  = (int) swapEndianess32(*ky);
#ifdef DEBUG
   printf("KEY=%d %08X/%08X : l=%d  %s\n",key,key,*ky,pcontent.size,t+2);
#endif
   if(-6< key  && key <0)
    {
     //      printf("extract Lists from  key=%d\n",key);
     if(key == -1)
      {
       int catAnz = unsplit(tp,255,t+2,DBsep2,pcontent.size-2);
       for(int i=0;i<catAnz ; i++)
	{
	 if(tp[i][1] == DBsep && tp[i][3]==DBsep)
	  {
	   int catno = tp[i][2];
// 	   printf("catRead  %3d/%3d:  no =%3d name='%s'\n",i,catAnz,catno,tp[i]+4);
	   if(catno<=0 || catno >=255)
	    continue;
	   addCategory(catno,tp[i]+4);
// 	   printf("add Cat '%s'\n",tp[i]+4);
	  }
	}
      }
     continue;
    }
    


   //   printf("add App key-%08X len=%d\n",key,pcontent.size);
   cal.add(key,t,pcontent.size);
    
  } 
  pdbp->close(pdbp);

//   strcpy(DBbuffer+2,"Schedule:schedule:0.11");
//   DBbuffer[0] =0;
//   DBbuffer[1] =0;
//   writeDB(-2,DBbuffer,24);


  if(DBInputVersion != 11)
   {
    //          
    strcpy(DBbuffer+2,"Schedule:schedule:0.11");
    DBbuffer[0] =0;
    DBbuffer[1] =0;
    writeDB(-2,DBbuffer,24);
   }
  return true;
}

void writeDB(int key,char *content, int len)
{
 DB *pdbp;

 pdbp = dbopen(DBfile,  O_RDWR, 0664, DB_HASH, NULL);
 if(!pdbp) 
  {
   perror("dbopen:");
   printf("Can't open DBfile\n",DBfile);
   exit(-1);
  }
 writeDB(pdbp,key,content,len);
 pdbp->close(pdbp);
}

void writeDB(DB *pdbp,int key,char *content, int len)
{
 DBT pkey, pcontent;
 char kbuf[64];
 unsigned int *ky;
 int status;

 memset(kbuf,0,63);
 ky = (unsigned int *) kbuf;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 *ky = swapEndianess32((unsigned int *) &key);
 
 pcontent.data = (void *) content;
 pcontent.size = len;
 if( (status = pdbp->put(pdbp, &pkey, &pcontent,0)) != 0)
  {
   printf("Error write to DB at entry (key =%%08X) status=%d\n",key,status);
   exit(-1);
  }
}

void readFromDB(int key, Appointment *app)
{
 DB *pdbp;
 DBT pkey, pcontent;
 int status;
 char kbuf[256],*t,buf2[256];
 unsigned int *ky;
 int rkey;



 pdbp = dbopen(DBfile, O_RDONLY, 0664, DB_HASH, NULL);
 if( pdbp)
  {
   memset(kbuf,0,63);
   ky = (unsigned int *) kbuf;
   pkey.data = (void *) kbuf;
   pkey.size = 4;
   *ky = swapEndianess32((unsigned int *) &key);
   if ( status = pdbp->get(pdbp, &pkey, &pcontent,0) == 0)
    {
     char *t = (char *)pcontent.data;
     //     printf("::: %s\n",t+2);
     app->fill(-2,key,(char *)pcontent.data,pcontent.size);
    }
   else
    {
     printf ("error:: errno=%d key=%8X %d DBfile %s\n",errno,key,key,DBfile);
     perror(">>>");
     app->id =-1;
    } 
   pdbp->close(pdbp);
  }
 else
  {
   app->id =-1;
   printf("con't open\n");
  }
}

void deleteFromDB(int key)
{
 DB *pdbp;
 DBT pkey;
 char kbuf[64];
 unsigned int *ky;
 int status;

 pdbp = dbopen(DBfile,  O_RDWR, 0664, DB_HASH, NULL);
 if(!pdbp) 
  {
   perror("dbopen:");
   printf("Can't open DBfile\n",DBfile);
   exit(-1);
  }

 memset(kbuf,0,63);
 ky = (unsigned int *) kbuf;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 *ky = swapEndianess32((unsigned int *) &key);
 if( (status = pdbp->del(pdbp,&pkey,0) ) != 0)
  {
   printf("error deleteing entry with key %d %08X\n",key,key);
  }
 // writeDB(pdbp,key,content,len);
 
 pdbp->close(pdbp);
}


void createAlarmDB ()
{
 DB *pdbp;
 DBT pkey, pcontent;
 char kbuf[64];
 unsigned int *ky;
 int status;

 if(alarmFile == NULL)
  initFileNames();

 pdbp = dbopen(alarmFile, O_CREAT | O_TRUNC | O_RDWR, 0664, DB_HASH, NULL);
 if(!pdbp) 
  {
   printf("error 1\n");
   exit(-1);
  }
 
 //               123456789012345678901234567890
 strcpy(DBbuffer,"Calendrian:Alarm:0.01");
 DBbuffer[0] =0;
 DBbuffer[1] =0;
 
 memset(kbuf,0,63);
 ky = (unsigned int *) kbuf;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 int key =-1;
 *ky = swapEndianess32((unsigned int *) &key);
 
 pcontent.data = (void *) DBbuffer;
 pcontent.size = 22;
 pdbp->put(pdbp, &pkey, &pcontent,0);
 pdbp->close(pdbp);
 
}
void checkAlarmDB ()
{
 DB *pdbp;

 if(alarmFile == NULL)
  initFileNames();

 pdbp = dbopen(alarmFile, O_RDONLY, 0664, DB_HASH, NULL);
 if(!pdbp) 
  createAlarmDB();
 else
  pdbp->close(pdbp);  
}


void rereadAlarmDB()
{
 alarms.count=0;
 readAlarmDB();
}
void readAlarmDB()
{
 DB *pdbp;
 DBT pkey, pcontent;
 int status;
 char kbuf[256],*t,buf2[256];
 char *buffer;
 int bufLen=0;
 char *tp[264];
 unsigned int *ky,kp;
 int key;


 if(alarmFile == NULL)
  initFileNames();

 buffer = new char [1024];
 bufLen =1020;               // keep some 4 bytes empty to be onthe save side
 ky=(unsigned int *) kbuf;

 pdbp = dbopen(alarmFile, O_RDONLY, 0664, DB_HASH, NULL);
 if(pdbp) 
  {
   status = pdbp->seq(pdbp, &pkey, &pcontent,R_CURSOR);
   for(int status = pdbp->seq(pdbp, &pkey, &pcontent, R_FIRST); 
       status == 0; 
       status = pdbp->seq(pdbp, &pkey, &pcontent, R_NEXT))
    {
     memset(kbuf,0,255);
     memcpy(kbuf,pkey.data,pkey.size);
     kbuf[pkey.size] ='\0';
     key  = (int) swapEndianess32(*ky);
     if( key == -1)
      continue;
     //     printf("AlarmDB key=%08X\n",key);

     if(pcontent.size  > bufLen )
      {
       if(buffer != NULL)
	delete [] buffer;
       while (bufLen < pcontent.size)
	bufLen += 1024;
       buffer = new char [bufLen +4];
      }
     memcpy(buffer,pcontent.data,sizeof(char) *(pcontent.size+2));

     //     printf("alarm buffer : /%s/\n",buffer);
     int anz = unsplit(tp,255,buffer,',');
     
     //     printf("%d alarms for key %08X\n",anz,key);
     for (int i=0;i<anz && i <4; i++)
      {
       unsigned int tim = atoi(tp[i]);
       //       printf("\t\ttim(%1d)=%d\n",i,tim);
       if( tim > 0)
	{
	 //	 printf("add alarm at %8d fro key=%d.%1d\n",tim,key,i);
	 alarms.add(key,tim,i);
	}
      }
    }     
  }
 pdbp->close(pdbp);
}

void writeAlarmItem2DB(int key, time_t alarmTime[4])
{
 DB *pdbp;
 DBT pkey, pcontent;
 char kbuf[64];
 unsigned int *ky;
 int status;
 char buffer[256];

 sprintf(buffer,"%10u,%01u,%10u,%10u",alarmTime[0],alarmTime[1],alarmTime[2],alarmTime[3]);
 memset(kbuf,0,63);
 ky = (unsigned int *) kbuf;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 *ky = swapEndianess32((unsigned int *) &key);

 pcontent.data = (void *) buffer;
 pcontent.size = strlen(buffer)+1;

 
 pdbp = dbopen(alarmFile,  O_RDWR, 0664, DB_HASH, NULL);
 if(!pdbp) 
  {
   perror("dbopen:");
   printf("Can't open DBfile '%s'\n",alarmFile);
   exit(-1);
  }

 // printf("weite Alarms for %08X: %s\n",key,buffer);
 
 if( (status = pdbp->put(pdbp, &pkey, &pcontent,0)) != 0)
  {
   printf("Error write to DB at entry (key =%%08X) status=%d\n",key,status);
   exit(-1);
  }
 pdbp->close(pdbp);
}

int unsplit(char **tp,int max, char *s,char sep)
{
 int i=0;
 char *s0=s;

 tp[i] =s;
 i++;
 do
  {
   s=skip2NextSep(s,sep);
   if ( s == NULL)
    break;
   *s='\0';
   s++;
   tp[i]=s;
   // printf("tp(%2d)='%s'/%d\n",i,tp[i],tp[i]-s0);
   i++;
  }while(i<max && *s !='\0');
 return i;
}

int unsplit(char **tp,int max, char *s,char sep,int len)
{
 int i=0;
 char *s0=s;

 tp[i] =s;
 i++;
 do
  {
   while(s-s0 < len && *s != sep)
    s++;
   if(s-s0>=len)
   //   s=skip2NextSep(s,sep);
    //   if ( s == NULL)
    break;
   *s='\0';
   s++;
   tp[i]=s;
   //   printf("tp(%2d)='%s'/%d\n",i,tp[i],tp[i]-s0);
   i++;
  }while(i<max && s-s0 < len);
 return i;
}







char *skip2NextSep(char *t,char sep)
{
 char *s;

 if (t==NULL)
  return NULL;

 if( (s= strchr(t,sep)) == NULL)
  return NULL;
   
 return s;
}

char *skip2Next(char *t,char sep)
{
 char *s;

 if (t==NULL)
  return NULL;

 if( (s= strchr(t,sep)) == NULL)
  return NULL;
   
 return s+1;
}
char *extractNext (char *t,char sep, char *dup)
{
 char *s;
 int l;

 dup[0]='\0';
 if (t==NULL)
  return dup;
 
 s = strchr(t,sep);
 if (s == NULL)
  return dup;

 l=s-t;
 strncpy(dup,t,l);
 dup[l]='\0';
 return(dup);
}
