// File: utils.cc
//
// Time-stamp: <28-May-2003 20:09:19 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: Ruediger Goetz
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>


#include "calendrian.h"
//#include "acal_gui.h"



static Fl_Select_Browser *editLocList;
static Fl_Button *editLocDone, *editLocAdd, *editLocDelete;
static Fl_Input *editLocInput;
static Fl_App_Window *editLocWindow;
static Fl_Dockable_Window *editLocTB;
static int currentLoc=-1;
static Fl_Select_Browser *editCatList;
static Fl_Button *editCatDone, *editCatAdd, *editCatDelete;
static Fl_Input *editCatInput;
static Fl_App_Window *editCatWindow;
static Fl_Dockable_Window *editCatTB;
static int currentCat=-1;
static int addInput=true;

void addLocation (Fl_Widget *w);
void addCategory (Fl_Widget *w);
void doneEditLocation (Fl_Widget *w);
void doneEditCategory (Fl_Widget *w);
void fillLocList();
void fillCatList();
void setCurrentLocation (Fl_Widget *w);
void setCurrentCategory (Fl_Widget *w);
void editLocCheckEmpty(Fl_Widget *w);
void editCatCheckEmpty(Fl_Widget *w);
void modifyLocation(Fl_Widget *w);
void modifyCategory(Fl_Widget *w);
void deleteLocation(Fl_Widget *w);
void deleteCategory(Fl_Widget *w);


char * add2Buffer(char *buf,int bufLen,int val, char sep)
{
 int l;
 char txt[64];
 sprintf(txt,"%d",val);
 l=strlen(txt);
 memcpy(buf,txt,sizeof(char)*l);
 buf[l]=sep;
 l++;
 buf[l]='\0';
 return buf +l; 
}
char * add2Buffer(char *buf,int bufLen,char *txt, char sep,int add0)
{
 int l;
 if(txt== NULL || *txt =='\0')
  l=0;
 else
  {
   l=strlen(txt);
   memcpy(buf,txt,sizeof(char)*l);
   if(add0)
    {
     buf[l]='\0';
     l++;
    }
  }
 buf[l]=sep;
 l++;
 buf[l]='\0';
 return buf +l; 
}
char * add2Buffer(char *buf,int bufLen,char *txt,int txtLen, char sep)
{
 int l=txtLen;

 if(txt== NULL)
  l=0;
 else
  memcpy(buf,txt,sizeof(char)*l);

 buf[l]=sep;
 l++;
 buf[l]='\0';
 return buf +l; 
}

unsigned int swapEndianess32(unsigned int i)
{
#ifdef BIG_ENDIAN
 return( (i&0xFF000000) >> 24 |  (i&0x00FF0000) >> 8 | (i&0x0000FF00) << 8 |  (i&0x000000FF) <<24);
#else
 return(i);
#endif
}
unsigned int swapEndianess32(unsigned int *i)
{
#ifdef BIG_ENDIAN
 return( (*i&0xFF000000) >> 24 |  (*i&0x00FF0000) >> 8 | (*i&0x0000FF00) << 8 |  (*i&0x000000FF) <<24);
#else
 return(*i);
#endif
}

void addCategory(int id,const char *txt)
{
 int len =  strlen(txt);
 addCategory(id,txt,len);
}
void addCategory(int id,const char *txt,char sep)
{
 char *t = strchr(txt,sep);
 if( t!=NULL)
  addCategory(id,txt,t-txt);
}
void addCategory(int id,const char *txt,int len)
{
 if(0<id && id <256)
  {
   if(categories[id] != NULL)
    delete [] categories[id];

   categories[id] =  new char [len+4];
   strncpy(categories[id],txt,len+1);
   categories[id][len] ='\0';
  }
}
void addLocation(int id,const char *txt)
{
 if(0<= id && id <256)
  {
   if(locations[id] != NULL)
    delete [] locations[id];

   int l =strlen(txt)+4;
   locations[id] =  new char [l];
   strncpy(locations[id],txt,l-2);
   locations[id][l-2] ='\0';
  }
}

void  writeCategories()
{
 char *t,tmp[256];
 int size,l;

 DBbuffer[0]=0;
 DBbuffer[1]=0;
 t=DBbuffer+2;
 size=2;
 for(int i=1;i<MAX_CATEGORIES  ; i++)
  if(categories[i] != NULL)
   {
    l = strlen(categories[i]) + 5;
    size+= l;
    sprintf(tmp,"%c%c%c%c%s%c",0,DBsep,i,DBsep,categories[i],DBsep2);
    memcpy(t,tmp,sizeof(char)*l);

    printf("write Cat %d with len %d -> %d:\n",i,l,size);
    char *s=DBbuffer;
    for(int i=2; i<size; i++)
     {
      if(s[i]<' ')
       printf(" 0x%2X ",s[i]);
      else
       printf("%c",s[i]);
     }
    printf("\n");
    t+=l;
   }
 size++;
 *t='\0';
//  t++;
//  size++;
//  *t='\0';

 printf("writeCategories: flag=%3d/%02X  cat=%d linesize=%d\n",DBbuffer[0],DBbuffer[0],DBbuffer[1],size);
 t=DBbuffer;
 for(int i=2; i<size; i++)
  {
   if(t[i]<' ')
    printf(" 0x%2X ",t[i]);
   else
    printf("%c",t[i]);
  }
 printf("\n\n");

 writeDB(-1,DBbuffer,size);
}


void setCategory(Fl_Widget *w,void * cat)
{
 int l=(int ) cat;
 if(l <0)
  w->label("All");
 else
  w->label(categories[l]);
 w->redraw();
}

void editLocation(void );
void editLocation(Fl_Widget *w,void *d )
{
 editLocation();
 // printf("edit LOc\n");
}
void editLocation(void )
{
 // editLocWindow = new Fl_App_Window(160,220);
 editLocWindow = WidgetFactory::new_window("Edit Location");


 editLocList= new Fl_Select_Browser ( 2,2,156,188);
 editLocList->textsize(10);
 fillLocList();
 editLocList->callback(setCurrentLocation);

 editLocTB =  WidgetFactory::new_toolbar();
 editLocTB->begin();
 editLocTB->size(160,30);


 // editLocInput = new  Fl_Input(2,190,158,14);
 editLocInput = new  Fl_Input(2,0,156,14);
 editLocInput->textsize(10);
 editLocInput->callback(editLocCheckEmpty);
 editLocInput->when(FL_WHEN_CHANGED|FL_WHEN_ENTER_KEY_ALWAYS);

 // editLocDone = new Fl_Button (0,205,40,14,"Done");
 editLocDone = new Fl_Button (0,15,40,14,"Done");
 editLocDone->labelsize(10);
 editLocDone->callback(doneEditLocation);
 
 // editLocAdd = new Fl_Button (40,205,40,14,"Add");
 editLocAdd = new Fl_Button (40,15,40,14,"Add");
 editLocAdd->labelsize(10);
 editLocAdd->callback(addLocation);
 addInput=true;
 
 // editLocDelete = new Fl_Button (80,205,40,14,"Delete");
 editLocDelete = new Fl_Button (80,15,40,14,"Delete");
 editLocDelete->labelsize(10);
 editLocDelete->callback(deleteLocation);
 editLocTB->end();
 
 
 editLocWindow->add_dockable(editLocTB,1);

 editLocWindow->end();
 editLocWindow->show();
}

void fillLocList()  // Fixme sort Location by alpha
{
 editLocList->clear();
 for(int i=0;i<MAX_LOCATION; i++)
  if(locations[i] !=NULL)
   editLocList->add(locations[i]);
}

void editLocCheckEmpty(Fl_Widget *w)
{
 const char *t =editLocInput->value();
 int key = Fl::event_key();
 //rintf("check Empty %d %d\n",Fl::event_key(),FL_Enter);
 if(key ==  FL_Enter)
  {
   if(addInput)
    addLocation(NULL);
   else
    modifyLocation(NULL);
  }
 else
  if(*t=='\0')
   {
    editLocAdd->label("Add");
    editLocAdd->callback(addLocation);
    addInput=true;
    editLocAdd->redraw();
   }
}

void setCurrentLocation (Fl_Widget *w)
{
 int l = editLocList->value();
 char *t;
 if (l>0)
  t = (char *) editLocList->text(l);  
 else
  t = NULL;

 currentLoc=-1;
 if( t != NULL)
  {
   for (int i=0; i<MAX_LOCATION ; i++)
    if(locations[i] != NULL)
     if(strcmp(locations[i],t) == 0)
      {
       currentLoc = i;
       break;
      }
   if(currentLoc>=0)
    editLocInput->value(locations[currentLoc]);
   editLocAdd->label("Modify");
   editLocAdd->callback(modifyLocation);
   addInput=false;
  }
 else
  {
   editLocInput->value("");
   editLocAdd->label("Add");
   editLocAdd->callback(addLocation);
   addInput=true;
  }
 editLocInput->redraw();
 editLocAdd->redraw();
}

void deleteLocation(Fl_Widget *w)
{
 printf("delete %d\n",currentLoc);
 if (locations[currentLoc] != NULL)
  {
   delete locations[currentLoc] ;
   locations[currentLoc] = NULL;
   savePrefs();
   currentLoc =-1;
  }
 editLocInput->value("");
 editLocAdd->label("Add");
 editLocAdd->callback(addLocation);
 addInput=true;

 fillLocList();
 editLocList->redraw();
 editLocInput->redraw();
 editLocWindow->redraw();
}

void modifyLocation(Fl_Widget *w)
{
 const char *loc = editLocInput->value();
 int l;

 if (locations[currentLoc] != NULL)
  {
   addLocation(currentLoc,loc);
   savePrefs();
   currentLoc =-1;
  }

 fillLocList();
 editLocInput->value("");
 editLocAdd->label("Add");
 editLocAdd->callback(addLocation);
 addInput=true;

 editLocList->redraw();
 editLocInput->redraw();
 editLocWindow->redraw();
}

void addLocation (Fl_Widget *w)
{
 const char *loc = editLocInput->value();
 int l,exists=false;;


 for (int i=0; i<MAX_LOCATION ; i++)
  if(locations[i] != NULL)
   if(strcmp(locations[i],loc) == 0)
    {
     exists=true;
    }
 if(!exists)
  {
   for (int i=0; i<MAX_LOCATION ; i++)
    if(locations[i] == NULL)
     { 
      printf("add Location '%s' on $d\n",loc,i);
      addLocation(i,loc);
      savePrefs();
      break;
     }
  }

 fillLocList();
 editLocInput->value("");

 editLocList->redraw();
 editLocInput->redraw();
 editLocWindow->redraw();
}

void doneEditLocation (Fl_Widget *w)
{
 editLocWindow->hide();
 delete editLocWindow;
 if(prefWin == NULL)
  editAppFillLocationsMenu();
}



//edit CCat
static  VoidFunction *fillCatMenu;

void editCategories(Fl_Widget *w,void *f)
{
 fillCatMenu = (VoidFunction *) f;
 // editCatWindow = new Fl_App_Window(160,220);
 editCatWindow = WidgetFactory::new_window("Edit Category");

 editCatList= new Fl_Select_Browser ( 2,2,156,188);
 editCatList->textsize(10);
 fillCatList();
 editCatList->callback(setCurrentCategory);

 editCatTB =  WidgetFactory::new_toolbar();
 editCatTB->begin();
 editCatTB->size(160,30);


 // editCatInput = new  Fl_Input(2,190,158,14);
 editCatInput = new  Fl_Input(2,0,156,14);
 editCatInput->textsize(10);
 editCatInput->callback(editCatCheckEmpty);
 editCatInput->when(FL_WHEN_CHANGED|FL_WHEN_ENTER_KEY_ALWAYS);

 // editCatDone = new Fl_Button (0,205,40,14,"Done");
 editCatDone = new Fl_Button (0,15,40,14,"Done");
 editCatDone->labelsize(10);
 editCatDone->callback(doneEditCategory);
 
 // editCatAdd = new Fl_Button (40,205,40,14,"Add");
 editCatAdd = new Fl_Button (40,15,40,14,"Add");
 editCatAdd->labelsize(10);
 editCatAdd->callback(addCategory);
 addInput=true;
 
 // editCatDelete = new Fl_Button (80,205,40,14,"Delete");
 editCatDelete = new Fl_Button (80,15,40,14,"Delete");
 editCatDelete->labelsize(10);
 editCatDelete->callback(deleteCategory);
 editCatTB->end();
 
 
 editCatWindow->add_dockable(editCatTB,1);

 editCatWindow->end();
 editCatWindow->show();
}

void fillCatList()  // Fixme sort Category by alpha
{
 editCatList->clear();
 for(int i=1;i<MAX_CATEGORIES ; i++)
  if(categories[i] !=NULL)
   editCatList->add(categories[i]);
}

void editCatCheckEmpty(Fl_Widget *w)
{
 const char *t =editCatInput->value();
 int key = Fl::event_key();
 //rintf("check Empty %d %d\n",Fl::event_key(),FL_Enter);
 if(key ==  FL_Enter)
  {
   if(addInput)
    addCategory(NULL);
   else
    modifyCategory(NULL);
  }
 else
  if(*t=='\0')
   {
    editCatAdd->label("Add");
    editCatAdd->callback(addCategory);
    addInput=true;
    editCatAdd->redraw();
   }
}

void setCurrentCategory (Fl_Widget *w)
{
 int l = editCatList->value();
 char *t;
 if (l>0)
  t = (char *) editCatList->text(l);  
 else
  t = NULL;

 currentCat=-1;
 if( t != NULL)
  {
   for (int i=0; i<MAX_CATEGORIES ; i++)
    if(categories[i] != NULL)
     if(strcmp(categories[i],t) == 0)
      {
       currentCat = i;
       break;
      }
   if(currentCat>=0)
    editCatInput->value(categories[currentCat]);
   editCatAdd->label("Modify");
   editCatAdd->callback(modifyCategory);
   addInput=false;
  }
 else
  {
   editCatInput->value("");
   editCatAdd->label("Add");
   editCatAdd->callback(addCategory);
   addInput=true;
  }
 editCatInput->redraw();
 editCatAdd->redraw();
}

void deleteCategory(Fl_Widget *w)
{
 printf("delete %d\n",currentCat);
 if (categories[currentCat] != NULL)
  {
   delete categories[currentCat] ;
   categories[currentCat] = NULL;
   writeCategories();
   currentCat =-1;
  }
 editCatInput->value("");
 editCatAdd->label("Add");
 editCatAdd->callback(addCategory);
 addInput=true;

 fillCatList();
 editCatList->redraw();
 editCatInput->redraw();
 editCatWindow->redraw();
}

void modifyCategory(Fl_Widget *w)
{
 const char *loc = editCatInput->value();
 int l;

 if (categories[currentCat] != NULL)
  {
   addCategory(currentCat,loc);
   writeCategories();
   currentCat =-1;
  }

 fillCatList();
 editCatInput->value("");
 editCatAdd->label("Add");
 editCatAdd->callback(addCategory);
 addInput=true;

 editCatList->redraw();
 editCatInput->redraw();
 editCatWindow->redraw();
}

void addCategory (Fl_Widget *w)
{
 const char *loc = editCatInput->value();
 int l,exists=false;;


 for (int i=0; i<MAX_CATEGORIES ; i++)
  if(categories[i] != NULL)
   if(strcmp(categories[i],loc) == 0)
    {
     printf("Category already exists\n");
     exists=true;
    }
 if(!exists)
  {
   for (int i=0; i<MAX_CATEGORIES ; i++)
    if(categories[i] == NULL)
     { 
      printf("add Category '%s' on $d\n",loc,i);
      addCategory(i,loc);
      writeCategories();
      //      savePrefs();
      break;
     }
  }

 fillCatList();
 editCatInput->value("");

 editCatList->redraw();
 editCatInput->redraw();
 editCatWindow->redraw();
}

void doneEditCategory (Fl_Widget *w)
{
 editCatWindow->hide();
 delete editCatWindow;
 // editAppFillCategoriesMenu();
 fillCatMenu();
}








int compareInts(const void *v1, const void *v2)
{
 int *i1,*i2;
 i1 =(int *) v1; 
 i2 =(int *) v2;
 return(*i1-*i2);
}




///// Find

char *findKey = NULL;
int findKeySize=0;

void findAppointments(Fl_Widget *w)
{
 

 const char *key = fl_input("Find Appointment(s) containing",0);
 int l = strlen(key);
 if( l>findKeySize)
  {
   if( findKey != NULL)
    delete findKey;
   findKey = new char [l+2];
   findKeySize =l;
  }
 strncpy(findKey,key,l);
 findKey[l]='\0';

 if (key != NULL)
  findNextAppointment(0);
}

int findNextAppointment(int start)
{
 static int cur,matchCount;

 if(start >=0)
  {
   cur =start;
   matchCount=0;
  }

 if(cur >=0)
  for(int i=cur; i <cal.all.count; i++)
   {
    if(strstr(cal.all.app[i]->title,findKey) != NULL)
     {
      char txt[31];
      struct tm *lt = localtime(&cal.all.app[i]->start);
      strftime(txt,31,"%Y-%m-%d %H:%M",lt);
      int ret = fl_choice("Found appointment matching '%s':\n %s \nat %s\nView it?","Next","View","Cancel",
			  findKey,cal.all.app[i]->title,txt);
      matchCount++;

      printf("ret=%d\n",ret);
      if(ret == 1)
       {
	editAppointment(cal.all.app[i]);
	return true;
       }
      else if(ret == 2)
       {
	findKey[0]='\0';
	cur=-1;
	return true;
       }
     }
   }

 if(matchCount == 0)
  fl_alert("No matches found\n");
 else
  fl_alert("No more matches found\n");
 return true;
}

